/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2008 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.human.dto;

import jp.mosp.common.common.BaseDto;

public class MKihonDto extends BaseDto {

	private static final long serialVersionUID = 3115468966868261668L;

	// tB[h
	private String  kcode  		= "";	//ЈR[h
	private String  simei  		= "";	//
	private String  furigana  	= "";	//ӂ肪
	private String  scode  		= "";	//R[h
	private String  ycode  		= "";	//ER[h
	private String  tokyu  		= "";	//
	private String  jcode  		= "";	//ƏR[h
	private int	 nydate 	= 0	;	//Г
	private int	 tsdate  	= 0	;	//ސE
	private String  knkubun  	= "";	//xސE敪
	private String  kykubun  	= "";	//^敪
	private String  txkubun  	= "";	//ŋ敪
	private String  txkubunx  	= "";	//̑ŋ敪
	private String  kmkubun  	= "";	//g敪
	private String  ptkubun  	= "";	//p[g敪
	private String  shkubun  	= "";	//x敪
	private String  siwakecd  	= "";	//dWvR[h
	private String  haigusya  	= "";	//}{z
	private int   	 fuyosu  	= 0	;	//}{Ƒ
	private double	 yukyu  	= 0	;	//Lc
	private int	 nenrei  	= 0	;	//N
	private int 	 kinzoku  	= 0	;	//ΑN
	private String  kenpono  	= "";	//۔ԍ
	private String  kohono  	= "";	//۔ԍ
	private String  kuser  		= "";	//[U
	private String  passw  		= "";	//pX[h
	private String  email  		= "";	//email
	private String  ninsyo  	= "";	//F؎
	private int  	 datalvl  	= 0	;	//f[^x
	private int  	 proglevel  = 0	;	//vOgp

	/**
	 * RXgN^
	 */
	public MKihonDto(){
		super();
	}

	// ANZT\bh
	public String  getKCode () 		{ return kcode 		; }		//ЈR[h
	public String  getSimei () 		{ return simei 		; }		//
	public String  getFurigana ()  	{ return furigana 	; }		//ӂ肪
	public String  getSCode () 		{ return scode 		; }		//R[h
	public String  getYCode () 		{ return ycode 		; }		//ER[h
	public String  getTokyu () 		{ return tokyu 		; }		//
	public String  getJCode () 		{ return jcode 		; }		//ƏR[h
	public int    	getNyDate () 	{ return nydate 	; }		//Г
	public int    	getTsDate () 	{ return tsdate 	; }		//ސE
	public String  getKnKubun () 	{ return knkubun 	; }		//xސE敪
	public String  getKyKubun () 	{ return kykubun 	; }		//^敪
	public String  getTxKubun () 	{ return txkubun 	; }		//ŋ敪
	public String  getTxKubunx () 	{ return txkubunx 	; }		//̑ŋ敪
	public String  getKmKubun () 	{ return kmkubun 	; }		//g敪
	public String  getPtKubun () 	{ return ptkubun 	; }		//p[g敪
	public String  getShKubun () 	{ return shkubun 	; }		//x敪
	public String  getSiwakeCd () 	{ return siwakecd 	; }		//dWvR[h
	public String  getHaigusya () 	{ return haigusya 	; }		//}{z
	public int    	getFuyosu () 	{ return fuyosu 	; }		//}{Ƒ
	public double 	getYukyu () 	{ return yukyu 		; }		//Lc
	public int    	getNenrei () 	{ return nenrei 	; }		//N
	public int   	getKinzoku () 	{ return kinzoku 	; }		//ΑN
	public String  getKenpoNo () 	{ return kenpono 	; }		//۔ԍ
	public String  getKohoNo () 	{ return kohono 	; }		//۔ԍ
	public String  getKUser () 		{ return kuser 		; }		//[U
	public String  getPassw () 		{ return passw 		; }		//pX[h
	public String  getEmail () 		{ return email 		; }		//email
	public String  getNinsyo () 	{ return ninsyo 	; }		//F؎
	public int    	getDataLvl () 	{ return datalvl 	; }		//f[^x
	public int   	getProgLevel () { return proglevel 	; }		//vOgp

	public void setKCode 		(String  KCode 		) 		{ this.kcode 	 	= KCode 	; }		//ЈR[h
	public void setSimei 		(String  Simei 		) 		{ this.simei  		= Simei 	; }		//
	public void setFurigana 	(String  Furigana 	) 		{ this.furigana  	= Furigana 	; }		//ӂ肪
	public void setSCode 		(String  SCode 		) 		{ this.scode  		= SCode 	; }		//R[h
	public void setYCode 		(String  YCode 		) 		{ this.ycode  		= YCode 	; }		//ER[h
	public void setTokyu 		(String  Tokyu 		) 		{ this.tokyu  		= Tokyu 	; }		//
	public void setJCode 		(String  JCode 		) 		{ this.jcode  		= JCode 	; }		//ƏR[h
	public void setNyDate 		(int     NyDate 	) 		{ this.nydate  		= NyDate 	; }		//Г
	public void setTsDate 		(int     TsDate 	) 		{ this.tsdate  		= TsDate 	; }		//ސE
	public void setKnKubun 	(String  KnKubun 	) 		{ this.knkubun  	= KnKubun 	; }		//xސE敪
	public void setKyKubun 	(String  KyKubun 	) 		{ this.kykubun  	= KyKubun 	; }		//^敪
	public void setTxKubun 	(String  TxKubun 	) 		{ this.txkubun  	= TxKubun 	; }		//ŋ敪
	public void setTxKubunx 	(String  TxKubunx	) 		{ this.txkubunx  	= TxKubunx 	; }		//̑ŋ敪
	public void setKmKubun 	(String  KmKubun 	) 		{ this.kmkubun  	= KmKubun 	; }		//g敪
	public void setPtKubun 	(String  PtKubun 	) 		{ this.ptkubun  	= PtKubun 	; }		//p[g敪
	public void setShKubun 	(String  ShKubun 	) 		{ this.shkubun  	= ShKubun 	; }		//x敪
	public void setSiwakeCd 	(String  SiwakeCd 	) 		{ this.siwakecd  	= SiwakeCd 	; }		//dWvR[h
	public void setHaigusya 	(String  Haigusya 	) 		{ this.haigusya  	= Haigusya 	; }		//}{z
	public void setFuyosu 		(int     Fuyosu 	) 		{ this.fuyosu  		= Fuyosu 	; }		//}{Ƒ
	public void setYukyu 		(double Yukyu 		) 		{ this.yukyu  		= Yukyu 	; }		//Lc
	public void setNenrei 		(int     Nenrei 	) 		{ this.nenrei  		= Nenrei 	; }		//N
	public void setKinzoku 	(int     Kinzoku 	) 		{ this.kinzoku  	= Kinzoku 	; }		//ΑN
	public void setKenpoNo	 	(String  KenpoNo 	) 		{ this.kenpono  	= KenpoNo 	; }		//۔ԍ
	public void setKohoNo 		(String  KohoNo 	) 		{ this.kohono  		= KohoNo 	; }		//۔ԍ
	public void setKUser 		(String  KUser 		) 		{ this.kuser  		= KUser 	; }		//[U
	public void setPassw 		(String  Passw 		) 		{ this.passw  		= Passw 	; }		//pX[h
	public void setEmail 		(String  Email 		) 		{ this.email  		= Email 	; }		//email
	public void setNinsyo 		(String  Ninsyo 	) 		{ this.ninsyo  		= Ninsyo 	; }		//F؎
	public void setDataLvl 	(int     DataLvl 	) 		{ this.datalvl  	= DataLvl 	; }		//f[^x
	public void setProgLevel 	(int     ProgLevel 	) 		{ this.proglevel 	= ProgLevel ; }		//vOgp

}
